#!/usr/bin/perl -w
#
#
# $Header: /home/cvsuser/public/mod_pgsqllog/contrib/mod_pgsqllog_utils/import.pl,v 1.1 2002/04/02 12:10:29 franco Exp $
# $Revision: 1.1 $
# $Date: 2002/04/02 12:10:29 $
# $Log: import.pl,v $
# Revision 1.1  2002/04/02 12:10:29  franco
# * mod_pgsqllog.c: Tested PostgreSQL connection recovery, added additional logging for aborted connections - franco
#
# * added contributed import script by Muness - franco
#
# Revision 1.4  2002/03/27 20:19:40  muness
# Put IP address/name in the correct field.
#
# Revision 1.3  2002/03/25 20:02:34  muness
# Misunderstood meaning of field named "hostname".  Fixed.
# Put client_hostname (as present in log file) in field client_hostname.  Note that this may actually be an IP address in some cases.
#
# Revision 1.2  2002/03/25 18:58:34  muness
# This works.
#
# Revision 1.1.1.1  2002/03/22 20:38:36  muness
# Import/Export tools for mod_pgsqllog will go here.
#
# Author: Muness Alrubaie <muness@lingerie.com>
#


BEGIN {
#Make sure the library files are in the path
     push(@INC, '/home/muness/log/perl-httplog');
}

#Configure these:
my $server_hostname = "SERVER NAME";
my $server_port = "80";
my $dbname = "DB NAME";
my $dbuser = "DB USER";
my $dbpass = "DB password";
 

#PostgreSQL
use Pg;

#HttpLogEntry library
use HttpLogEntry;
use HttpRequest;
use URL;
use InetAddr;

my $conn=Pg::connectdb("dbname=$dbname user=$dbuser password=$dbpass");

my $status=$conn->status;

if ($status == PGRES_CONNECTION_BAD) {
	die ("error: ", $conn->errorMessage);
}

my $mimeType = ""; #Placeholder
my $encoding = ""; #Placeholder
my $filename = ""; #Placeholder

my $ip ="";

while (<STDIN>) {
        my $logEntry = HttpLogEntry->new($_);
	my $client = $logEntry->client_host()->host();
	if ($client =~ m/[a-zA-Z]+/) {
		#Name
		$ip= ", '', '" . $client . "'"; 
	} else {
		#IP Address
		$ip= ",'" . $client . "', ''"; 
	}

	my $insert = "INSERT INTO apachelog VALUES ("
		. "'" . $server_hostname . "'" 
		. ", 'HTTP/" . $logEntry->request()->http_version() ."'"
		. ", '" . $mimeType . "'"
		. ", '" . $encoding . "'"
		. ", '" . $logEntry->request()->uri() . "'"
		. ", '" . $filename . "'"
		. ", '" . $server_hostname . "'"
		. ", '" . $server_port . "'"
		. ", '" . $logEntry->referrer()->url() . "'"
		. ", '" . $logEntry->agent() . "'"
		. $ip 
		. ", '" . $logEntry->user() . "'"
		. ", '" . $logEntry->request_time() . "'"
		. ", '" . $logEntry->response_size() . "'"
		. ", '" . $logEntry->request_status() . "'"
		. ", '" . $logEntry->request()->request_method() . "'"
		. " )";
	#$conn->exec($insert);
	print "$insert\n";
}
